﻿using WordPressPCL;
using WordPressPCL.Models;

namespace TestProject;

/// <summary>
/// 프로그램
/// </summary>
class Program
{
    //////////////////////////////////////////////////////////////////////////////////////////////////// Method
    ////////////////////////////////////////////////////////////////////////////////////////// Static
    //////////////////////////////////////////////////////////////////////////////// Private

    #region 프로그램 시작하기 - Main()

    /// <summary>
    /// 프로그램 시작하기
    /// </summary>
    /// <returns>태스크</returns>
    private async static Task Main()
    {
        string baseURL             = "https://somebody_wordpress.com/wp-json/";
        string userID              = "사용자ID";
        string applicationPassword = "애플리케이션 패스워드";

        WordPressClient client = new WordPressClient(baseURL);

        client.Auth.UseBasicAuth(userID, applicationPassword);

        IEnumerable<Category> categoryEnumerable = await client.Categories.GetAllAsync(useAuth : true);

        Dictionary<int, CategoryKeyModel> categoryKeyDictionary = new Dictionary<int, CategoryKeyModel>();

        foreach(Category category in categoryEnumerable.OrderBy(category => category.Parent * 10000 + category.Id))
        {
            if(category.Parent == 0)
            {
                CategoryKeyModel categoryKey = new CategoryKeyModel();

                categoryKey.KEY        = category.Name.ToUpper().Trim();
                categoryKey.PARENT_KEY = null;
                categoryKey.CATEGORY   = category;

                categoryKeyDictionary.Add(category.Id, categoryKey);
            }
            else
            {
                CategoryKeyModel parentCategoryKey = categoryKeyDictionary[category.Parent];

                CategoryKeyModel categoryKey = new CategoryKeyModel();

                categoryKey.KEY        = $"{parentCategoryKey.KEY}/{category.Name.ToUpper().Trim()}";
                categoryKey.PARENT_KEY = parentCategoryKey.KEY;
                categoryKey.CATEGORY   = category;

                categoryKeyDictionary.Add(category.Id, categoryKey);
            }
        }

        foreach(KeyValuePair<int, CategoryKeyModel> keyValuePair in categoryKeyDictionary)
        {
            CategoryKeyModel categoryKey = keyValuePair.Value;

            Console.WriteLine($"{categoryKey.KEY}, {categoryKey.CATEGORY.Name}");
        }
    }

    #endregion
}